#ifndef _SIM_COMMON_H_
#define _SIM_COMMON_H_

#include <stdint.h>
#include <math.h>

typedef uint32_t uintptr32_t;

#define FALSE 0
#define TRUE  1

// Number of bodies being simulated
#define NUM_BODIES  3072
// Integration step
#define TIMESTEP    0.01f

// Representation of a 3D vector
typedef struct _VEC3D {
  float x, y, z;
} VEC3D;

// Calculates square of a float
static inline float fsqrf(float a) {
  return a * a;
}

// Some alignment macros
#define QWORD_ALIGNED __attribute__((aligned(16)));
#define CACHE_ALIGNED __attribute__((aligned(128)));

#endif
